unit Akuzativo;

interface

uses 
  {$IFDEF LINUX} Libc, {$ENDIF} QT {$IFDEF MSWINDOWS} , Windows {$ENDIF}, SysUtils, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QButtons, QExtCtrls, KursoEsp, Funkcioj, 
  QStaticText;

type
  TFrame5 = class(TFrame)
    GradButton21: TImage;
    Label1: TLabel;
    Label6: TLabel;
    Bevel6: TBevel;
    Panel4: TPanel;
    Traduko1: TStaticText;
    Panel5: TPanel;
    Image2: TImage;
    Placar12: TStaticText;
    Panel6: TPanel;
    Image3: TImage;
    Placar13: TStaticText;
    Panel12: TPanel;
    Placar14: TStaticText;
    Panel13: TPanel;
    Image6: TImage;
    Placar11: TStaticText;
    Panel14: TPanel;
    BitBtn1: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn2: TBitBtn;
    Vortoj: TGroupBox;
    Vorto10: TStaticText;
    Vorto11: TStaticText;
    Vorto12: TStaticText;
    Vorto13: TStaticText;
    Vorto14: TStaticText;
    Vorto15: TStaticText;
    Vorto16: TStaticText;
    Vorto17: TStaticText;
    Vorto18: TStaticText;
    Vorto19: TStaticText;
    Vorto20: TStaticText;
    Klarigo: TLabel;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure VortKlako(Sender: TObject);
    procedure NovaFrazo;
    procedure Tradukilo(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Var
    iAleat2, iKorektaj, iEraraj: integer;
    aEk02D: TDigits;
    aEk02R: TDigits;
    aEk02A: TAleat;
    aEk02T: TFrazo;
    aEk02K: TDigits;
    Klarigoj: TFrazo;
    aFrazoElek: array[0..10] of string;
    iEk02D: integer;


implementation

uses Unit19;

{$R *.xfm}

procedure TFrame5.BitBtn1Click(Sender: TObject);
Var i: integer;
begin
   iEk02D := Matriz2(aEk02D,EkzercoAkuzativo,'D');
   Matriz2(aEk02R,EkzercoAkuzativo,'R');
   Matriz2(aEk02K, EkzercoAkuzativo, 'K');
   Matriz(aEk02T,EkzercoAkuzativoTrad,'T');
   if sLingvo = 'Portugus' then begin
      Klarigoj[0]:= 'Este  o sujeito da orao, e o sujeito NUNCA pode receber a terminao "n".';
      Klarigoj[1]:= 'Esta palavra  parte do sujeito, e o sujeito NUNCA pode receber a terminao "n".';
      Klarigoj[2]:= 'Este  o artigo definido. O artigo  uma palavra invarivel.';
      Klarigoj[3]:= 'Este  o verbo, e no pode receber a terminao "n".';
      Klarigoj[4]:= 'Parabns! Este  o objeto direto da orao e deve receber a terminao "n" !';
      Klarigoj[5]:= 'Muito bem! Esta palavra  parte do objeto direto e deve receber a terminao "n".';
      Klarigoj[6]:= 'Aps uma preposio no se deve usar a terminao "n".';
      Klarigoj[7]:= 'Isto  uma preposio. Ela no recebe a terminao "n".';
      Klarigoj[8]:= 'Isto  um advrbio. Ele no recebe a terminao "n".';
      Klarigoj[9]:= 'Deve-se usar o acusativo apenas quando o verbo age sobre algum ou alguma coisa. No  este o caso.';
      Klarigoj[10]:= 'Esta palavra  um numeral, e no recebe a terminao "n".';
      Klarigoj[11]:= 'Esta palavra  uma conjuno, e no recebe a terminao "n".';
      Klarigoj[12]:= 'Essas palavras recebem a terminao "n" porque so entendidas como uma simplificao de frases mais longas ("Mi diras saluton al vi", "Mi diras dankon al vi", etc.).';
      end
   else
      Matriz(Klarigoj, 'Klarigoj', 'T');
   BitBtn1.Enabled := false;
   BitBtn3.Enabled := true;
   Placar11.Caption := IntToStr(iEk02D);
   Placar12.Caption := '00';
   Placar13.Caption := '00';
   Placar14.Caption := '00%';
   iKorektaj := 0;
   iEraraj := 0;
   BitBtn2.Enabled := true;
   For i := 0 to iEk02D-1 do begin
       aEk02A[i] := false;
   end;
   randomize;
   NovaFrazo;
end;

procedure TFrame5.BitBtn3Click(Sender: TObject);
begin
   BitBtn1.Enabled := true;
   BitBtn3.Enabled := false;
   BitBtn2.Enabled := false;
   Vortoj.Visible := false;
   Traduko1.Visible := false;
   Klarigo.Visible := false;
end;

procedure TFrame5.BitBtn2Click(Sender: TObject);
Var i: integer;
    lPrava: boolean;
    NumSec: SmallInt;
    StartTime: TDateTime;
    iQuant : integer;
    Prov : TNotifyEvent;
begin
Prov := TButton(Sender).OnClick;
TButton(Sender).OnClick := nil;
lPrava := true;
for i := 0 to 9 do
    if (aFrazoElek[i] <> aEk02R[iAleat2,i]) and (trim(aEk02R[iAleat2,i]) <> '') then
       lPrava := false;
if lPrava then begin
   inc(iKorektaj);
   Placar11.Caption := IntToStr(StrToInt(Placar11.Caption) -1);
   Placar12.Caption := IntToStr(iKorektaj);
   Jes;
   Atendu(1);
   aEk02A[iAleat2] := true;
   end
else begin
   BitBtn2.Enabled := false;
   BitBtn3.Enabled := false;
   inc(iEraraj);
   Placar13.Caption := IntToStr(iEraraj);
   Ne;
   StartTime := now;
   NumSec := 3;
   iQuant := 0;
   repeat
      Application.ProcessMessages;
      if now > (StartTime + (iQuant * (1/24/60/60)) /3) then begin
         inc(iQuant);
         for i := 0 to Vortoj.ControlCount -1 do
             if (aFrazoElek[i] = '') and  (aEk02R[iAleat2,i] = '1') then
                TStaticText(Vortoj.Controls[i]).Visible := not TStaticText(Vortoj.Controls[i]).Visible;
         end;
   until Now > StartTime + NumSec * (1/24/60/60);
   for i := 0 to Vortoj.ControlCount -1 do
       TStaticText(Vortoj.Controls[i]).Visible := true;
   BitBtn2.Enabled := true;
   BitBtn3.Enabled := true;
   end;
   Placar14.Caption := IntToStr(round(iKorektaj/(iEraraj+iKorektaj)*100))+ '%';
   if Placar11.Caption <> '0' then
      NovaFrazo
   else begin
      Mesagxo(iEraraj, iKorektaj);{ prezentas gratulon mesagxon! }
      BitBtn3.Click;
      end;
TButton(Sender).OnClick := Prov;
end;

procedure TFrame5.VortKlako(Sender: TObject);
Var j,i: integer;
begin
   j := (Sender as TStaticText).Tag;
   if aEk02R[iAleat2,j] = '1' then begin
      if aFrazoElek[j] <> '1' then begin
         (Sender as TStaticText).Caption := (Sender as TStaticText).Caption + 'n';
         (Sender as TStaticText).Font.Color := clGreen;
         aFrazoElek [j] := '1';
         Noteto;
         for i := j+1 to Vortoj.ControlCount-1 do begin
            TStaticText(Vortoj.Controls[i]).Left :=
            TStaticText(Vortoj.Controls[i]).Left  + 8;
            end;
         end;
      end
   else begin
      inc(iEraraj);
      Placar13.Caption := IntToStr(iEraraj);
      Ne;
      Placar14.Caption := IntToStr(round(iKorektaj/(iEraraj+iKorektaj)*100))+ '%';
      (Sender as TStaticText).Font.Color := clRed;
   end;
   Klarigo.Caption := Klarigoj[StrToInt(aEk02K[iAleat2,j])];
   Klarigo.Visible := true;
   Atendu(1);
end;

procedure TFrame5.NovaFrazo;
var j, i, longeco, iVortoj, Komenca : integer;
begin
   Application.ProcessMessages;
   For j := 0 to 10 do
       aFrazoElek[j] := '';
   iAleat2 := random(iEk02D);
   while aEk02A[iAleat2] do
         iAleat2 := random(iEk02D);
   For i := 0 to Vortoj.ControlCount-1 do
       TStaticText(Vortoj.Controls[i]).Caption := aEk02D[iAleat2,i];
   Traduko1.Caption := aEk02T[iAleat2];
   Traduko1.Visible := true;
   Klarigo.Visible := false;
   iVortoj := 0;
   for j := 0 to 10 do
       if aEk02D[iAleat2,j] <> '' then
          inc(iVortoj);
   Longeco := 0;
   For i := 0 to Vortoj.ControlCount-1 do
       Longeco := Longeco + TStaticText(Vortoj.Controls[i]).Width;
   Longeco := Longeco + (6 * iVortoj ); // - (4 * (11 - iVortoj));
   Komenca := (Vortoj.Width - longeco) div 2;
   For i := 0 to Vortoj.ControlCount-1 do begin
       TStaticText(Vortoj.Controls[i]).Left := Komenca;
       Komenca := Komenca + 6 + TStaticText(Vortoj.Controls[i]).Width;
       end;
   Vortoj.Enabled := true;
   For i := 0 to Vortoj.ControlCount-1 do
       TStaticText(Vortoj.Controls[i]).Font.Color := clBlack;
   Vortoj.Visible := true;
end;

procedure TFrame5.Tradukilo(Sender: TObject);
begin
Tradukas(Sender, Name);
end;

end.
