unit Prononco;

interface

uses
  {$IFDEF LINUX} Libc, {$ENDIF} QT {$IFDEF MSWINDOWS} , Windows {$ENDIF}, SysUtils, Classes, QGraphics, QControls, QForms, QDialogs,
  QComCtrls, QStdCtrls, QExtCtrls, QButtons, Kursoesp,
  Funkcioj, QStaticText;

type
  TFrame2 = class(TFrame)
    GradButton25: TImage;
    PP_Label1: TLabel;
    PP_Label41: TLabel;
    PP_Panelo: TPanel;
    Bevel8: TBevel;
    PP_Mikrofono: TImage;
    PP_Orelo: TImage;
    PP_Antauen: TSpeedButton;
    PP_Aud_Re: TSpeedButton;
    PP_Mik_Re: TSpeedButton;
    PP_Paneleto: TPanel;
    PP_Panel15: TPanel;
    PP_Startu: TBitBtn;
    PP_Haltu: TBitBtn;
    PP_Panel16: TPanel;
    PP_Vorto: TPanel;
    PP_Prog: TTrackBar;
    Image7: TImage;
    PP_Placar: TStaticText;
    PP_Kiomope: TRadioGroup;
    procedure PP_StartuClick(Sender: TObject);
    procedure PP_HaltuClick(Sender: TObject);
    procedure PP_Mik_ReClick(Sender: TObject);
    procedure PP_Aud_ReClick(Sender: TObject);
    procedure PP_AntauenClick(Sender: TObject);
    procedure HaltigasPrononcon;
    procedure NovaFrazo9;
    Procedure RegistrasVocxon;
    function Horlogxo : boolean;
    procedure Tradukilo(Sender: TObject);
    procedure Stop;
    procedure Registru(var RegistraLongo: integer; FileName:string);
    procedure Close;
    procedure Savu(var FileName: string);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Var
  aEk09D: TFrazo;
  aEk09A: TAleat;
  aEk09F: array[1..4] of array[0..2] of integer;
  aEk09T: array[1..4] of array[0..1] of WideString;
  iAleat9, iEk09D, Kiome, KiomFoje: integer;
  RegistraLongo : integer;

implementation

uses Unit19;

{$R *.xfm}

procedure TFrame2.PP_StartuClick(Sender: TObject);
Var i: integer;
begin
if DirectoryExists(vojo+'sonoj/lec'+ copy(EkzercoPrononco,1,2)) then begin
   PP_Startu.Enabled := false;
   PP_Haltu.Enabled  := true;
   iEk09D := Matriz(aEk09D,EkzercoPrononco,'D');
   PP_Placar.Caption := IntToStr(iEk09D);
   for i := 0 to iEk09D-1 do
       aEk09A[i] := false;
   randomize;
   NovaFrazo9;
   end
else
   MessageDlg(smNeSono, mtInformation, [mbOK], 0);
end;

procedure TFrame2.PP_HaltuClick(Sender: TObject);
begin
   Kurso.MP3.Stop;
   Kurso.Mp3.InputClose;
   Stop;
   Close;
   PP_KiomOpe.Enabled := true;
   PP_Mikrofono.Visible := true;
   PP_Prog.Visible := false;
   PP_Orelo.Visible := false;
   PP_Vorto.Caption := '';
   PP_Mik_Re.Enabled := false;
   PP_Aud_Re.enabled := false;
   PP_Antauen.Enabled := false;
   PP_Startu.Enabled := true;
   PP_Haltu.Enabled := false;
   Application.ProcessMessages;
   PP_Placar.Caption := '00';
end;

procedure TFrame2.PP_Mik_ReClick(Sender: TObject);
begin
   RegistrasVocxon;
end;

procedure TFrame2.PP_Aud_ReClick(Sender: TObject);
Var i: integer;
    x: String;
begin
if PP_Haltu.Enabled then begin
   PP_Orelo.Visible := true;
   PP_Mik_Re.Enabled := false;
   PP_Aud_Re.Enabled := false;
   PP_Antauen.Enabled := false;
   PP_KiomOpe.Enabled := false;
   Application.ProcessMessages;
   For i := 1 to kiome do begin   // Ludas Registritan Vocxon;
       If not PP_Haltu.Enabled then
          Break;
       PP_Vorto.Caption := aEk09T[i,0];
       Kurso.mp3.InputOpen(aEk09T[i,1]);
       Sinkronigu;
       Kurso.mp3.play;
       Sinkronigu;

       x := sWavPlay + ' ' + PorTempa + 'tempa'+IntToStr(i)+'.wav';
       Libc.System(pchar(x));

       end;
   PP_Orelo.Visible := false;
   PP_Mik_Re.Enabled := true;
   PP_Aud_Re.Enabled := true;
   PP_Antauen.Enabled := true;
   PP_KiomOpe.Enabled := true;
   PP_Vorto.Caption := '';
   Application.ProcessMessages;
   end;
end;

procedure TFrame2.PP_AntauenClick(Sender: TObject);
begin
   if StrtoIntDef(PP_Placar.Caption,0) <= 0 then begin
      PP_Haltu.Click;
      Application.ProcessMessages;
      end
   else
      NovaFrazo9;
end;

Function TFrame2.Horlogxo : boolean;
begin
{if PP_Haltu.Enabled then begin
   mciSendString('status Sono mode', ProvLoko, 50, 0);
   if (trim(ProvLoko) = 'recording') then begin
      mciSendString('status Sono position', ProvLoko, 50,0);
      Pozicio := StrToIntDef(trim(ProvLoko),0);
      PP_Prog.Position := round ( (Pozicio/(aEk09F[KiomFoje,0]*1000)) * 100);
      Application.ProcessMessages;
      result := false;
      end
   else
      result := true;
   end
else
   result := true;}
   result := true;
end;

Procedure TFrame2.RegistrasVocxon;
Var i: integer;
    FileName : String;
begin
If PP_Haltu.Enabled then begin
   PP_Mik_Re.Enabled := false;
   PP_Aud_Re.Enabled := false;
   PP_Antauen.Enabled := false;
   PP_KiomOpe.Enabled := false;
   For i := 1 to kiome do begin   // iRegistrasVocxon;
       If not PP_Haltu.Enabled then
          Break;
       PP_Vorto.Caption := aEk09T[i,0];
       Kurso.mp3.InputOpen(aEk09T[i,1]);
       PP_Mikrofono.Visible := false;
       PP_Orelo.Visible := true;
       Sinkronigu;
       aEk09F[i,0] := SonLongeco + 3;
       Kurso.mp3.play;
       Atendu(SonLongeco);
       Kurso.Mp3.Stop;
       Sinkronigu;
       PP_Orelo.Visible := false;
       KiomFoje := i;
       RegistraLongo := (1000 * aEk09F[i,0]);
       PP_Mikrofono.Visible := true;
       Application.ProcessMessages;

       PP_Prog.Visible := true;
       FileName := PorTempa + '/tempa'+IntToStr(i)+'.wav';
       Registru(RegistraLongo, FileName);

       PP_Mikrofono.Visible := false;
       PP_Prog.Visible := false;
       PP_Prog.Position := 0;
       Application.ProcessMessages;

       end;
   PP_Aud_Re.Click;
   end;
end;

procedure TFrame2.NovaFrazo9;
Var i: integer;
    sTeksto: String;
Begin
Application.ProcessMessages;
If PP_Haltu.Enabled then begin
   PP_KiomOpe. Enabled := false;
   PP_Mikrofono.Visible := false;
   Kiome := StrToInt(PP_Kiomope.Items[PP_Kiomope.ItemIndex]);
   if StrtoIntDef(PP_Placar.Caption,0) < Kiome then
      Kiome := StrtoIntDef(PP_Placar.Caption,0);
   for I := 1 to kiome do begin
       iAleat9 := random(iEk09D);
       While aEk09A[iAleat9] do
             iAleat9 := random(iEk09D);
       aEk09A[iAleat9] := true;
       if StrToIntDef(aEk09D[iAleat9],0) > 0 then begin
          aEk09T[i,1] := Vojo + 'sonoj/lec' + copy(EkzercoPrononco,1,2)+ '/btn' + aEk09D[iAleat9] + '.mp3';
          aEk09T[i,0] := TButton(Parent.Parent.Parent.FindComponent('Button'+aEk09D[iAleat9])).Caption;
          end
       else begin
          aEk09T[i,0] := aEk09D[iAleat9];
          sTeksto := CxSist(aEk09D[iAleat9],1);
          if sTeksto = 'aux' then
             sTeksto := 'auh';
          aEk09T[i,1] := Vojo + 'sonoj/lec' + copy(EkzercoPrononco,1,2) + '/'+sTeksto+'.mp3';
          end;
       end;
   RegistrasVocxon;
   if PP_Haltu.Enabled then
      PP_Placar.Caption := IntToStr(StrtoIntDef(PP_Placar.Caption,0) - Kiome);
   end;
end;

procedure TFrame2.HaltigasPrononcon;
begin
   if PP_Haltu.Enabled then begin
      PP_Haltu.Click;
      Application.ProcessMessages;
      end;
end;

procedure TFrame2.Tradukilo(Sender: TObject);
begin
Tradukas(Sender, Name);
end;

procedure TFrame2.Stop;
Begin
//   mciSendString('stop Sono', nil, 0, 0);
end;

procedure TFrame2.Registru(var RegistraLongo: integer; FileName: string);
Var Ordono: string;
Begin
Ordono := sWavRec + ' ' + FileName;
Libc.System(pChar(Ordono));
end;

procedure TFrame2.Savu(var FileName: string);
Begin
{   Ordono := 'save Sono ' +  FileName;
   mciSendString(PChar(Ordono), nil, 0, 0);
   mciSendString('close Sono', nil, 0, 0); }
end;

procedure TFrame2.Close;
Begin
//   mciSendString('close Sono', nil, 0, 0);
end;

end.
