unit SubaParto;

interface

uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QExtCtrls, QButtons, QStdCtrls, Funkcioj, QComCtrls;

type
  TFrame6 = class(TFrame)
    Savu: TSpeedButton;
    Malantauen: TSpeedButton;
    koverto: TSpeedButton;
    Helpo: TImage;
    Eliri: TSpeedButton;
    Antauen: TSpeedButton;
    procedure EliriClick(Sender: TObject);
    procedure kovertoClick(Sender: TObject);
    procedure SavuClick(Sender: TObject);
    procedure MalantauenClick(Sender: TObject);
    procedure AntauenClick(Sender: TObject);
    procedure PagxaroShangho;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

{$R *.xfm}

procedure TFrame6.EliriClick(Sender: TObject);
begin
if Savu.Enabled then
   SavasEk( TPageControl(TForm(Parent).FindComponent('Pagxaro')) );
   TForm(Parent).Close;
end;

procedure TFrame6.kovertoClick(Sender: TObject);
begin
   SendasMsg(TPageControl(TForm(Parent).FindComponent('Pagxaro')) );
end;

procedure TFrame6.SavuClick(Sender: TObject);
begin
   SavasEk(TPageControl(TForm(Parent).FindComponent('Pagxaro')) );
   Savu.Enabled := false;
end;

procedure TFrame6.MalantauenClick(Sender: TObject);
begin
With TPageControl(TForm(Parent).FindComponent('Pagxaro'))  do
     if ActivePageIndex > 0 then
        ActivePage := Pages[ActivePageIndex - 1]
     else
        ActivePage := Pages[PageCount -1];
   PagxaroShangho;

end;

procedure TFrame6.AntauenClick(Sender: TObject);
begin
With TPageControl(TForm(Parent).FindComponent('Pagxaro')) do
     if ActivePageIndex < PageCount -1 then
        ActivePage := Pages[ActivePageIndex + 1]
     else
        ActivePage := Pages[0];
PagxaroShangho;
end;

procedure TFrame6.PagxaroShangho;
Begin
   Koverto.visible := (TPageControl(TForm(Parent).FindComponent('Pagxaro')).ActivePage.Tag = 128);
   savu.visible := true;
   Helpo.Visible := (Koverto.Visible) or (TPageControl(TForm(Parent).FindComponent('Pagxaro')).ActivePage.Tag = 2);
End;

end.
