unit VortLudo;

interface

uses
  {$IFDEF LINUX} Libc, {$ENDIF} QT {$IFDEF MSWINDOWS} , Windows {$ENDIF}, SysUtils, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QButtons, QExtCtrls, KursoEsp, QComCtrls,
  Funkcioj, QStaticText;

type
  TFrame1 = class(TFrame)
    GradButton21: TImage;
    Label7: TLabel;
    Bevel32: TBevel;
    Panel13: TPanel;
    Vorto: TStaticText;
    Panel14: TPanel;
    Image7: TImage;
    Placar16: TStaticText;
    Panel15: TPanel;
    Image8: TImage;
    Placar17: TStaticText;
    Panel16: TPanel;
    Placar18: TStaticText;
    Panel17: TPanel;
    Image9: TImage;
    Placar15: TStaticText;
    Panel18: TPanel;
    BitBtn18: TBitBtn;
    BitBtn20: TBitBtn;
    RxLabel1: TStaticText;
    Grupo: TGroupBox;
    Grupo0: TCheckBox;
    Grupo1: TCheckBox;
    Grupo2: TCheckBox;
    Grupo3: TCheckBox;
    Grupo4: TCheckBox;
    procedure BitBtn18Click(Sender: TObject);
    procedure BitBtn20Click(Sender: TObject);
    procedure GrupoClick(Sender: TObject);
    procedure NovaFrazo3;
    procedure Tradukilo(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Const
   PurigasLinion = '                                1';

Var
  iKorektaj3, iEraraj3, iAleat3, iPozicio: integer;
  aEk03D: TFrazo;
  aEk03R: TFrazo;
  aEk03A: TAleat;
  iEk03D: integer;
  aEk03T: TFrazo;
  iAktualaPagho : integer;

implementation

uses Unit19;


{$R *.xfm}

procedure TFrame1.BitBtn18Click(Sender: TObject);
begin
   iAktualaPagho := TPageControl(Grupo.Parent.Parent.Parent.Parent).ActivePageIndex;
   iEk03D := Matriz(aEk03D,EkzercoVortoLudo,'D');
   Matriz(aEk03R,EkzercoVortoLudo,'R');
   BitBtn18.Enabled := false;
   BitBtn20.Enabled := true;
   Placar15.Caption := IntToStr(iEk03D);
   Placar16.Caption := '00';
   Placar17.Caption := '00';
   Placar18.Caption := '00%';
   iKorektaj3 := 0;
   iEraraj3 := 0;
   Grupo.Visible := true;
   Vorto.Visible := true;
   Grupo0.Visible := true;
   Grupo1.Visible := true;
   Grupo2.Visible := true;
   Grupo3.Visible := true;
   Grupo4.Visible := true;
   randomize;
   NovaFrazo3;
end;

procedure TFrame1.BitBtn20Click(Sender: TObject);
Var i: integer;
begin
   BitBtn18.Enabled := true;
   BitBtn20.Enabled := false;
   for i := 0 to iEk03D do
       aEk03A[i] := false;
   Vorto.Visible := false;
   Grupo.Visible := false;
end;

procedure TFrame1.GrupoClick(Sender: TObject);
Var
NumSec: SmallInt;
StartTime: TDateTime;
iQuant : integer;
Prov : TNotifyEvent;
begin
If (Sender is TCheckBox) then begin
Prov := (Sender as TCheckBox).OnClick;
(Sender as TCheckBox).OnClick := nil;
Grupo.Enabled := false;
Application.ProcessMessages;
if (Sender as TCheckBox).Tag = iPozicio then begin
   inc(iKorektaj3);
   Placar16.Caption := IntToStr(iKorektaj3);
   Placar15.Caption := IntToStr(iEk03D - iKorektaj3);
   aEk03A[iAleat3] := true;
   Jes;
   Atendu(2);
   end
else begin
   inc(iEraraj3);
   Placar17.Caption := IntToStr(iEraraj3);
   Ne;
   BitBtn20.Enabled := false;
   StartTime := now;
   NumSec := 4;
   iQuant := 0;
   repeat
       Application.ProcessMessages;
       if now > (StartTime + (iQuant * (1/24/60/60)) /3) then begin;
          inc(iQuant);
          case iPozicio of
             0: Grupo0.Visible := not Grupo0.Visible;
             1: Grupo1.Visible := not Grupo1.Visible;
             2: Grupo2.Visible := not Grupo2.Visible;
             3: Grupo3.Visible := not Grupo3.Visible;
             4: Grupo4.Visible := not Grupo4.Visible;

          end;
       end;
   until Now > StartTime + NumSec * (1/24/60/60);
   Grupo0.Visible := true;
   Grupo1.Visible := true;
   Grupo2.Visible := true;
   Grupo3.Visible := true;
   Grupo4.Visible := true;
   BitBtn20.Enabled := true;
   end;
if iKorektaj3 > 0 then
   Placar18.Caption := IntToStr(round(iKorektaj3/(iEraraj3+iKorektaj3)*100))+ '%'
else
   Placar18.Caption := '00%';
if iKorektaj3 < iEk03D then begin
   NovaFrazo3;
   (Sender as TCheckBox).State := cbUnChecked;
   if ((Grupo.parent.parent.parent.parent as TPageControl).ActivePageIndex = iAktualaPagho) then
      Grupo.SetFocus;
   end
else begin
   Mesagxo(iEraraj3, iKorektaj3);
   (Sender as TCheckBox).State := cbUnChecked;
   BitBtn20.Click;
   end;
(Sender as TCheckBox).OnClick := Prov;
end;
end;

procedure TFrame1.NovaFrazo3;
Var sTekstoD, sTekstoR : Widestring;
    i, iAleat2: integer;
    aPozicio : TAleat;
begin
Application.ProcessMessages;
If BitBtn20.Enabled then begin
  for i := 0 to iEk03D do
      aPozicio[i] := false;
  iAleat3 := random(iEk03D);
  While aEk03A[iAleat3] do
     iAleat3 := random(iEk03D);
  if  (StrToIntDef(aEk03D[iAleat3], 0) > 0) then
     sTekstoD := TButton(Parent.Parent.Parent.FindComponent('Button'+aEk03D[iAleat3])).Caption
  else
     sTekstoD := aEk03D[iAleat3];
  sTekstoR := TLabel(Parent.Parent.Parent.FindComponent('Label'+aEk03R[iAleat3])).Caption;
  Vorto.Caption := sTekstoD;
  iPozicio := random(5);
  aPozicio[iAleat3] := true;
  Case iPozicio of
       0 : Grupo0.Caption := sTekstoR;
       1 : Grupo1.Caption := sTekstoR;
       2 : Grupo2.Caption := sTekstoR;
       3 : Grupo3.Caption := sTekstoR;
       4 : Grupo4.Caption := sTekstoR;
       end;

  for i := 0 to 4 do
      if i <> iPozicio then begin
         iAleat2 := random(iEk03D);
         While aPozicio[iAleat2] do
             iAleat2 := random(iEk03D);
         aPozicio[iAleat2] := true;
         sTekstoR := TLabel(Parent.Parent.Parent.FindComponent('Label'+aEk03R[iAleat2])).Caption;
        Case i of
             0 : Grupo0.Caption := sTekstoR;
             1 : Grupo1.Caption := sTekstoR;
             2 : Grupo2.Caption := sTekstoR;
             3 : Grupo3.Caption := sTekstoR;
             4 : Grupo4.Caption := sTekstoR;
             end;
      end;
  Grupo.Enabled := true;
  end;  
end;

procedure TFrame1.Tradukilo(Sender: TObject);
begin
Tradukas(Sender, Name);
end;

end.
