{$UNDEF CER}
unit kursoesp;


interface

uses
  {$IFDEF LINUX} Libc, {$ENDIF} {$IFDEF MSWINDOWS} Windows, {$ENDIF} SysUtils, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QExtCtrls, QComCtrls, inifiles,
  XaudioPlayer, QButtons,
  QClipbrd, QStaticText, QWinCursors, QFontComboBox,
  QFileListbox, CmdExecThread;

type TDigits = array[0..100] of array[0..10] of Widestring;
type TFrazo = array[0..100] of Widestring;
type TAleat = array[0..100] of boolean;
type TRKSInifile = TInifile;

type
  TKurso = class(TForm)
    mp3: TXaudioPlayer;
    Lec01: TSpeedButton;
    Lec07: TSpeedButton;
    Lec02: TSpeedButton;
    Lec08: TSpeedButton;
    Lec03: TSpeedButton;
    Lec09: TSpeedButton;
    Lec04: TSpeedButton;
    Lec10: TSpeedButton;
    Lec05: TSpeedButton;
    Lec11: TSpeedButton;
    Lec06: TSpeedButton;
    Lec12: TSpeedButton;
    KieButono: TSpeedButton;
    KioEstas: TSpeedButton;
    KielUzi: TSpeedButton;
    Konfigurado: TSpeedButton;
    Kreditoj: TSpeedButton;
    Eliri: TSpeedButton;
    Ligilo: TSpeedButton;
    Label2: TLabel;
    Lec05A: TSpeedButton;
    FileListBox1: TFileListBox;
    Komando: TCmdExecComponent;
    JEN_LUDU: TCmdExecComponent;
    procedure KiuLingvo;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Lec01Click(Sender: TObject);
    procedure fcShapeBtn7Click(Sender: TObject);
    procedure Lec02Click(Sender: TObject);
    procedure Lec03Click(Sender: TObject);
    procedure Lec04Click(Sender: TObject);
    procedure Lec05Click(Sender: TObject);
    procedure Lec06Click(Sender: TObject);
    procedure Lec07Click(Sender: TObject);
    procedure Lec08Click(Sender: TObject);
    procedure Lec09Click(Sender: TObject);
    procedure Lec10Click(Sender: TObject);
    procedure Lec11Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure KieButonoClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure mp3NotifyPlayerState;
    procedure Lec12Click(Sender: TObject);
    procedure KioEstasClick(Sender: TObject);
    procedure EliriClick(Sender: TObject);
    procedure KonfiguradoClick(Sender: TObject);
    procedure KreditojClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure KielUziClick(Sender: TObject);
    procedure ligiloClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure mp3NotifyOutputState(Sender: TXaudioPlayer; State: Integer);
    procedure Image1Click(Sender: TObject);
    procedure mp3NotifyStreamDuration(Sender: TXaudioPlayer;
      Duration: Cardinal);
    procedure mp3NotifyPong(Sender: TXaudioPlayer; Tag: Cardinal);
    procedure mp3NotifyInputTimecode(Sender: TXaudioPlayer; Hours, Minutes,
      Seconds, Fractions: Byte);
    procedure Lec05AClick(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
    Tradukota: TObject;
  end;

//  const
//  cr = WideChar(#10);
//  cr2 = WideChar(#10) + WideChar(#10);

const
    EkzPortugale : array[1..12] of array [0..1] of WideString =
    (('',''),('De acordo com a traduo, preencha os espaos em branco com a parte que falta. Lembre-se de colocar o plural "j" e o acusativo "n" onde necessrio. Quando achar que a frase est completada corretamente, clique no boto em baixo ou ' +
      'pressione Enter para confirmao. Tente obter no mnimo 70% de acerto.',''), ('',''), ('',''),
     ('Orientando-se pela traduo, preencha o espao em branco com o correlativo adequado. ' +
      'Atente que alguns correlativos podero ter a terminao do plural e/ou do acusativo. ' +
      'Quando achar que a frase est completada corretamente, clique no boto em baixo ou ' +
      'pressione Enter para confirmao. Tente obter no mnimo 70% de acerto.',''),
     ('De acordo com a traduo, preencha o espao em branco com a preposio adequada. Quando achar que a frase est completada corretamente, clique no boto em baixo ou pressione Enter para confirmao. Tente obter no mnimo 70% de acerto.',''),
     ('De acordo com a traduo, preencha o espao em branco com a palavra adequada. Quando achar que a frase est completada corretamente, clique no boto em baixo ou pressione Enter para confirmao. Tente obter no mnimo 70% de acerto.',
      'De acordo com a traduo, preencha o espao em branco com o prefixo ou sufixo adequado. Coloque tambm as terminaes gramaticais, ' +
      'onde necessrio. Quando achar que a frase est completada corretamente, clique no boto em baixo ou pressione Enter para confirmao. Tente obter no mnimo 70% de acerto.'),
     ('De acordo com a traduo, preencha o espao em branco com o sufixo adequado, no se esquecendo das terminaes gramaticais. Quando achar que a frase est completada corretamente, clique no boto em baixo ou ' +
      'pressione Enter para confirmao. Tente obter no mnimo 70% de acerto.',''),
     ('De acordo com a traduo, preencha o espao em branco com a terminao verbal adequada. Quando achar que a frase est completada corretamente, clique no boto em baixo ou pressione Enter para confirmao. Tente obter no mnimo 70% de acerto.',
      'De acordo com a traduo, preencha o espao em branco com o pronome adequado. Lembre-se que, conforme sua funo na frase, o pronome poder receber as terminaes "a", "aj" e "n". Quando achar que a frase est ' +
      'completada corretamente, clique no boto em baixo ou pressione Enter para confirmao. Tente obter no mnimo 70% de acerto.'),
     ('',''), ('',''), ('',''));

Var
  Kurso: TKurso;
  sEnhavujo : String; { kiu TForm estas nun tradukata }
  Tradukilo : boolean; {Kiam vera, i ebligas tradukadon rekte en la programo}
  lSupersigno, lTildo, lSxaltilo: boolean;
  cSuperSigno1, cSuperSigno2 : char;
  iPagAtual: integer;
  LastaLeciono, LastaPagxo: integer; { Para ir onde parou }
  Vojo : WideString; { la nomo de la disko + dosierujo kie trovias la programo }
  KieMiHaltis: boolean; { Se clicou boto para ir onde parou }
  Konfiguro: TIniFile;
  Tradukado: TRKSIniFile;
  iLastaFojo : integer;
  SonLongeco : integer;
  SonLongeco1 : integer;
  MP3Haltinta: Boolean = true;
  ElirejoFermita: Boolean = true;
  Pongo : Integer;
  Surbendigo: Boolean = true;
  KDROMO: Boolean = false;
  Portempa : WideString;
  SonLeciono : string; // Uzata por indiki al Funkcioj.pas, kie estas la ludota mp3-dosiero.
  AntauaLitero : WideChar;
  cr, cr2 : WideString;
//  fcsKodaro : TFontCharSet;

  { MemorLokoj por Konfiguro}
  sLingvo, sTiparo, sKorNomo, sKorAdreso, sTradukoDosiero, sTradukinto: WideString;
  iSistemo, iKodaro: integer;
  lKorektanto, lCxapeligo: boolean;
  sEsperanta_Tiparo : WideString;
  sMP3, sWavPlay, sWavRec, sNavigilo, sMesaghilo : String;

  { Variaoj uzataj por mesaoj }
  smRekomencu, smGratulon, smDenove, smModifis, smTondujo,smDevasHaviKor,
  smDevasSavi, smKoverto, smDisketo, smPordo, smLigilo, smNePasvorto,
  OK, Antauen, Nuligi, smNeSono, smPrononcoNetrovita: WideString;

  { Variaoj por indiki kiun ekzercon devas uzi Frame1, Frame2 kaj Frame3 }
  EkzercoVortoLudo, EkzercoPrononco, EkzercoAudado, EkzercoAkuzativo,
  EkzercoAkuzativoTrad : string;



implementation

uses lec01, lec02, lec03, lec04, lec05, lec06, lec07, lec08, lec09, lec10,
  lec11, lec12, konfig, Menuo4,
  LingvoElekto, lec05A, Figurejo_d, Funkcioj;

{$R *.xfm}





procedure TKurso.FormKeyPress(Sender: TObject; var Key: Char);
begin
  Cxapelo(Key, Sender);
end;


procedure TKurso.fcShapeBtn7Click(Sender: TObject);
begin
Close;
end;

procedure TKurso.Lec01Click(Sender: TObject);
Var Savita: TCursor;
begin
   Savita := Screen.Cursor;
   Screen.Cursor := crAppStart;
   Haltu;
   try begin
     Form1 := TForm1.Create(Kurso);
     Form1.ShowModal;
     Form1.Release;
     end
   finally Screen.Cursor := Savita
   end;
end;

procedure TKurso.Lec02Click(Sender: TObject);
Var Savita: TCursor;
begin
   Savita := Screen.Cursor;
   Screen.Cursor := crAppStart;
   Haltu;
   try begin
     Form2 := TForm2.Create(Kurso);
     Form2.ShowModal;
     Form2.Release;
     end
   finally Screen.Cursor := Savita
   end;
end;

procedure TKurso.Lec03Click(Sender: TObject);
Var Savita: TCursor;
begin
   Savita := Screen.Cursor;
   Screen.Cursor := crAppStart;
   Haltu;
   try begin
     Form3 := TForm3.Create(Kurso);
     Form3.ShowModal;
     Form3.Release;
     end
   finally Screen.Cursor := Savita
   end;
end;

procedure TKurso.Lec04Click(Sender: TObject);
Var Savita: TCursor;
begin
   Savita := Screen.Cursor;
   Screen.Cursor := crAppStart;
   Haltu;
   try begin
     Form4 := TForm4.Create(Kurso);
     Form4.ShowModal;
     Form4.Release;
     end
   finally Screen.Cursor := Savita
   end;
end;

procedure TKurso.Lec05Click(Sender: TObject);
Var Savita: TCursor;
begin
   Savita := Screen.Cursor;
   Screen.Cursor := crAppStart;
   Haltu;
   try begin
     Form5 := TForm5.Create(Kurso);
     Form5.ShowModal;
     Form5.Release;
     end
   finally Screen.Cursor := Savita
   end;
end;

procedure TKurso.Lec06Click(Sender: TObject);
Var Savita: TCursor;
begin
   Savita := Screen.Cursor;
   Screen.Cursor := crAppStart;
   Haltu;
   try begin
     Form6 := TForm6.Create(Kurso);
     Form6.ShowModal;
     Form6.Release;
     end
   finally Screen.Cursor := Savita
   end;
end;

procedure TKurso.Lec07Click(Sender: TObject);
Var Savita: TCursor;
begin
   Savita := Screen.Cursor;
   Screen.Cursor := crAppStart;
   Haltu;
   try begin
     Form7 := TForm7.Create(Kurso);
     Form7.ShowModal;
     Form7.Release;
     end
   finally Screen.Cursor := Savita
   end;
end;

procedure TKurso.Lec08Click(Sender: TObject);
Var Savita: TCursor;
begin
   Savita := Screen.Cursor;
   Screen.Cursor := crAppStart;
   Haltu;
   try begin
     Form8 := TForm8.Create(Kurso);
     Form8.ShowModal;
     Form8.Release;
     end
   finally Screen.Cursor := Savita
   end;
end;

procedure TKurso.Lec09Click(Sender: TObject);
Var Savita: TCursor;
begin
   Savita := Screen.Cursor;
   Screen.Cursor := crAppStart;
   Haltu;
   try begin
     Form9 := TForm9.Create(Kurso);
     Form9.ShowModal;
     Form9.Release;
     end
   finally Screen.Cursor := Savita
   end;
end;

procedure TKurso.Lec10Click(Sender: TObject);
Var Savita: TCursor;
begin
   Savita := Screen.Cursor;
   Screen.Cursor := crAppStart;
   Haltu;
   try begin
     Form10 := TForm10.Create(Kurso);
     Form10.ShowModal;
     Form10.Release;
     end
   finally Screen.Cursor := Savita
   end;
end;

procedure TKurso.Lec11Click(Sender: TObject);
Var Savita: TCursor;
begin
   Savita := Screen.Cursor;
   Screen.Cursor := crAppStart;
   Haltu;
   try begin
     Form11 := TForm11.Create(Kurso);
     Form11.ShowModal;
     Form11.Release;
     end
   finally Screen.Cursor := Savita
   end;
end;

procedure TKurso.Lec12Click(Sender: TObject);
Var Savita: TCursor;
begin
   Savita := Screen.Cursor;
   Screen.Cursor := crAppStart;
   Haltu;
   try begin
     Form12 := TForm12.Create(Kurso);
     Form12.ShowModal;
     Form12.Release;
     end
   finally Screen.Cursor := Savita
   end;
end;

procedure TKurso.FormShow(Sender: TObject);
begin
   KieMiHaltis := false;
   lSxaltilo   := true;
   Saluton;
end;

procedure TKurso.KieButonoClick(Sender: TObject);
begin
   KieMiHaltis := true;
   case LastaLeciono of
   1: Lec01.Click;
   2: Lec02.Click;
   3: Lec03.Click;
   4: Lec04.Click;
   5: Lec05.Click;
   6: Lec05A.Click;
   7: Lec06.Click;
   8: Lec07.Click;
   9: Lec08.Click;
   10: Lec09.Click;
   11: Lec10.Click;
   12: Lec11.Click;
   13: Lec12.Click;
   end;
   KieMiHaltis := false;
end;

procedure TKurso.FormCreate(Sender: TObject);
Var KonfigVojo: TextFile;
    Linio : string;
    PathPoz, EgalaPoz: integer;
begin
  cr := WideChar(10);
  cr2 := cr + cr;

  if Screen.Height <= 480 then
     Kurso.Top := 0
  else
     Kurso.Top := (Screen.Height - Kurso.Height) div 2;

  Kurso.Left := (Screen.Width - Kurso.Width) div 2;
  Lec02.Glyph := Lec01.Glyph;
  Lec03.Glyph := Lec01.Glyph;
  Lec04.Glyph := Lec01.Glyph;
  Lec05.Glyph := Lec01.Glyph;
  Lec05A.Glyph := Lec01.Glyph;
  Lec06.Glyph := Lec01.Glyph;
  Lec07.Glyph := Lec01.Glyph;
  Lec08.Glyph := Lec01.Glyph;
  Lec09.Glyph := Lec01.Glyph;
  Lec10.Glyph := Lec01.Glyph;
  Lec11.Glyph := Lec01.Glyph;
  iLastaFojo := 0;
//  Tiparo.Items := Screen.Fonts;
  AssignFile(KonfigVojo, '/etc/kurso.conf');
  Reset(KonfigVojo);
  while not(eof(KonfigVojo)) do begin
     readln(KonfigVojo, linio);
     PathPoz := pos('path', linio);
     EgalaPoz := pos('=', linio);
     if ( (PathPoz > 0) and (EgalaPoz > PathPoz) ) then begin
        Vojo := trim(copy(linio,EgalaPoz+1, length(linio)));
        Break;
        end;
     end;
  CloseFile(KonfigVojo);
  PorTempa := GetEnvironmentVariable('HOME');
  if copy(vojo,length(vojo),1) <> '/' then
     vojo := vojo + '/';
  if copy(PorTempa,length(Portempa),1) <> '/' then
     PorTempa := PorTempa + '/';
  PorTempa := Portempa + '.kurso/';
  if not DirectoryExists(PorTempa) then
     CreateDir(Portempa);
  Konfiguro := TIniFile.Create(PorTempa + 'konfig.ini');

  Screen.Cursors[20] := QWinCursors.LoadCursorFromFile(Vojo + 'figuroj/akuzativ.cur');
  Screen.Cursors[21] := QWinCursors.LoadCursorFromFile(Vojo + 'figuroj/sono.cur');

  FileListBox1.Directory := Vojo + 'tradukoj/';
  Application.ProcessMessages;
  Traduku;
end;

procedure TKurso.mp3NotifyPlayerState;
begin
  if (Screen.ActiveForm <> nil) then begin
     SonLongeco := 0;
     if (Screen.ActiveForm = Form11) then begin
        if (not Form11.Butono1.Enabled) then
           Form11.Butono1.Enabled := true;
        end
     else if (Screen.ActiveForm = Form2) then begin
        if (not Form2.Butono1.Enabled) then begin
//           Form2.Butono3.Enabled := false;
           Form2.Butono1.Enabled := true;
           end
        end
     else if (Screen.ActiveForm = Form8) then begin
        if (not Form8.Butono1.Enabled) then
           Form8.Butono1.Enabled := true;
        end
     else if (Screen.ActiveForm = Form9) then begin
        if (not Form9.Butono1.Enabled) then
           Form9.Butono1.Enabled := true;
        if (not Form9.BitBtn7.Enabled) then
           Form9.BitBtn7.Enabled := true;
        if (not Form9.BitBtn10.Enabled) then
           Form9.BitBtn10.Enabled := true;
        end
     else if (Screen.ActiveForm = Form6) then begin
        if (not Form6.Butono1.Enabled) then
           Form6.Butono1.Enabled := true;
        if (not Form6.BitBtn4.Enabled) then
           Form6.BitBtn4.Enabled := true;
        end
     else if (Screen.ActiveForm = Form4) then begin
        if (not Form4.Butono1.Enabled) then
           // Form4.Butono3.Click;
        end;
     Application.ProcessMessages;
     end;

end;

procedure TKurso.KioEstasClick(Sender: TObject);
Var x : String;
begin
if sLingvo = 'Portugues' then
   x := Vojo + 'tradukoj/kioestas.htm'
else
   x := Vojo + 'tradukoj/' + Tradukado.ReadString('Traduko', 'KioDosiero', 'kio_ang.htm');
VokasEksteran(x, 1);
end;

procedure TKurso.EliriClick(Sender: TObject);
begin
   Close;
end;

procedure TKurso.KonfiguradoClick(Sender: TObject);
Var Savita: TCursor;
begin
   Savita := Screen.Cursor;
   Screen.Cursor := crAppStart;
   try begin
     Form13 := TForm13.Create(Kurso);
     Form13.ShowModal;
     Form13.Release;
     end
   finally Screen.Cursor := Savita
   end;
end;


procedure TKurso.KreditojClick(Sender: TObject);
Var Savita: TCursor;
begin
   Savita := Screen.Cursor;
   Screen.Cursor := crAppStart;
   try begin
     Form15 := TForm15.Create(Kurso);
     Form15.ShowModal;
     Form15.Release;
     end
   finally Screen.Cursor := Savita
   end;
end;




procedure TKurso.FormDestroy(Sender: TObject);
begin
  Konfiguro.Free;
  Tradukado.Free;
end;





procedure TKurso.KielUziClick(Sender: TObject);
Var x: String;
begin
if sLingvo = 'Portugues' then
   x := Vojo + 'tradukoj/kieluzi.htm'
else
   x := Vojo + 'tradukoj/' + Tradukado.ReadString('Traduko', 'KielDosiero', 'kiel_ang.htm');
VokasEksteran(x, 1);
end;

procedure TKurso.ligiloClick(Sender: TObject);
Var x: String;
begin
   x := (Sender as TSpeedButton).Caption;
   VokasEksteran(x, 1);
end;

procedure TKurso.KiuLingvo;
begin
if Konfiguro.ReadString('Gxenerala', 'Lingvo', '') = '' then
   try
     Form17 := TForm17.Create(Kurso)
   finally
     Form17.ShowModal;
     Form17.Release;
   end;
end;



procedure TKurso.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
With konfiguro do begin
     WriteInteger('Gxenerala', 'LastaLeciono', LastaLeciono);
     WriteInteger('Gxenerala', 'LastaPagxo', LastaPagxo);
     UpdateFile;
     end;
Adiau;
end;

procedure TKurso.mp3NotifyOutputState(Sender: TXaudioPlayer;
  State: Integer);
begin
{If (State = XA_OUTPUT_STATE_CLOSED) then
   ElirejoFermita := true
else
   ElirejoFermita := false;}
end;

procedure TKurso.Image1Click(Sender: TObject);
begin
  Haltu;
end;

procedure TKurso.mp3NotifyStreamDuration(Sender: TXaudioPlayer;
  Duration: Cardinal);
begin
  SonLongeco := Duration;
end;

procedure TKurso.mp3NotifyPong(Sender: TXaudioPlayer; Tag: Cardinal);
begin
   Pongo := Tag;
end;


procedure TKurso.mp3NotifyInputTimecode(Sender: TXaudioPlayer; Hours,
  Minutes, Seconds, Fractions: Byte);
begin
  if ( SonLongeco > 140 ) and ( SonLongeco < 150) then
      if Form2.Butono1.Visible AND (not Form2.Butono1.Enabled) then
         Form2.Karaokeo(Hours, Minutes, Seconds, Fractions);

end;

procedure TKurso.Lec05AClick(Sender: TObject);
Var Savita: TCursor;
begin
   Savita := Screen.Cursor;
   Screen.Cursor := crAppStart;
   Haltu;
   try begin
     Form5A := TForm5A.Create(Kurso);
     Form5A.ShowModal;
     Form5A.Release;
     end
   finally Screen.Cursor := Savita
   end;
end;


procedure TKurso.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
If ( (Key = Ord('t')) or (Key = Ord('T') ) and (ssCtrl in Shift) ) then begin
   If Konfiguro.ReadBool('Gxenerala', 'Tradukilo', False) then begin
      Tradukilo := false;
      ShowMessage('La Tradukilo malaktivighis.');
      end
   Else begin
      Tradukilo := true;
      ShowMessage('La Tradukilo aktivighis.');
      end;
   Konfiguro.WriteBool('Gxenerala', 'Tradukilo', Tradukilo);
   Konfiguro.UpdateFile;
   Key := 0;
   end;


end;

end.

