unit leciono;

interface

uses
  {$IFDEF LINUX} Libc, {$ENDIF} QT {$IFDEF MSWINDOWS} , Windows {$ENDIF}, Messages, SysUtils, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QButtons, QComCtrls, QExtCtrls, kursoesp, Funkcioj,
  QStaticText_CLX, QRxLabel_CLX;

type
  TLecionejo = class(TForm)
    Pagxaro: TPageControl;
    Supra: TImage;
    Suba: TImage;
    koverto: TSpeedButton;
    Savu: TSpeedButton;
    Malantauen: TSpeedButton;
    Antauen: TSpeedButton;
    PaghoNumero: TStaticText;
    Eliri: TSpeedButton;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure kovertoClick(Sender: TObject);
    procedure SavuClick(Sender: TObject);
    procedure EliriClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MalantauenClick(Sender: TObject);
    procedure AntauenClick(Sender: TObject);
    procedure PagxaroShangho;
    procedure Tradukilo(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Lecionejo: TLecionejo;

implementation

uses Unit19, Figurejo_d;

{$R *.XFM}

procedure TLecionejo.FormShow(Sender: TObject);
begin
With Pagxaro do begin
   if KieMiHaltis then begin
      ActivePage := Pages[LastaPagxo];
      end
   else begin
      ActivePage := Pages[0];
      end;
   end;
   PagxaroShangho;
end;

procedure TLecionejo.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   LastaLeciono := Tag;
   LastaPagxo := Pagxaro.ActivePage.PageIndex;
end;

procedure TLecionejo.FormCreate(Sender: TObject);
begin
   Koverto.Hint := smKoverto;
   Savu.Hint := smDisketo;
   Eliri.Hint := smPordo;
end;

procedure TLecionejo.SavuClick(Sender: TObject);
begin
   Kurso.SavasEk(Pagxaro);
   Savu.Enabled := false;
end;

procedure TLecionejo.EliriClick(Sender: TObject);
begin
if Savu.Enabled then
   Kurso.SavasEk( Pagxaro );
Close;
end;


procedure TLecionejo.Edit2Change(Sender: TObject);
begin
   Savu.Enabled := true;
end;


procedure TLecionejo.kovertoClick(Sender: TObject);
begin
   Kurso.SendasMsg(Pagxaro);
end;

procedure TLecionejo.FormKeyPress(Sender: TObject; var Key: Char);
begin
  Kurso.Cxapelo(Key, TObject(ActiveControl));
end;

Procedure TLecionejo.MalantauenClick(Sender: TObject);
begin
With Pagxaro do
     if ActivePageIndex > 0 then
        ActivePage := Pages[ActivePageIndex - 1]
     else
        ActivePage := Pages[Pagxaro.PageCount -1];
   PagxaroShangho;
end;

Procedure TLecionejo.PagxaroShangho;
Begin
   Koverto.visible := ((Pagxaro.ActivePage as TTabSheet).Tag = 128);
   savu.visible := koverto.visible;
   PaghoNumero.Caption := IntToStr(Pagxaro.ActivePageIndex+1) + '/' + IntToStr(Pagxaro.PageCount);
End;

procedure TLecionejo.AntauenClick(Sender: TObject);
begin
With Pagxaro do
     if ActivePageIndex < Pagxaro.PageCount -1 then
        ActivePage := Pages[ActivePageIndex + 1]
     else
        ActivePage := Pages[0];
PagxaroShangho;
end;

procedure TLecionejo.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_NEXT then
     Antauen.Click
  else if Key = VK_PRIOR then
     Malantauen.Click;
end;

procedure TLecionejo.Tradukilo(Sender: TObject);
begin
   Tradukas(Sender, Name);
end;

end.
