#!/bin/sh

ETC_CFG=/etc/kurso.conf
BIN_DIR=/usr/bin
LIB_DIR=/usr/lib
INS_DIR=/usr/share/kurso

rm -f ${ETC_CFG}

rm -f ${BIN_DIR}/kurso
rm -f ${BIN_DIR}/kurso3

rm -f ${LIB_DIR}/libborqt-6.9-qt2.3.so
rm -f ${LIB_DIR}/libborqt-6.9.0-qt2.3.so

rm -fr ${INS_DIR}

mkdir ${INS_DIR}

tar xvzf kurso-inst.tar.gz -C ${INS_DIR}

ln -s ${INS_DIR}/bin/kurso3 ${BIN_DIR}/kurso
ln -s ${INS_DIR}/bin/kurso3 ${BIN_DIR}/kurso3

ln -s ${INS_DIR}/lib/libborqt-6.9-qt2.3.so ${LIB_DIR}/libborqt-6.9-qt2.3.so
ln -s ${INS_DIR}/lib/libborqt-6.9-qt2.3.so ${LIB_DIR}/libborqt-6.9.0-qt2.3.so

echo "path=${INS_DIR}" > ${ETC_CFG}
