unit LingvoElekto;

interface

uses
  {$IFDEF LINUX} Libc, {$ENDIF} QT {$IFDEF MSWINDOWS} , Windows {$ENDIF}, SysUtils, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, Kursoesp, inifiles, Funkcioj;

type
  TForm17 = class(TForm)
    Tradukoj: TListBox;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form17: TForm17;

implementation

uses Figurejo_d;

{$R *.xfm}

procedure TForm17.FormCreate(Sender: TObject);
Var LingvoListo : TStrings;
    LokaLingvo : string;
    Itemo, i: integer;
    Prov : TIniFile;
begin
   LokaLingvo := uppercase(GetEnvironmentVariable('LANG'));
   Tradukoj.Font := Screen.HintFont;
//   GetLocaleInfo (LOCALE_USER_DEFAULT, Locale_SABBREVLANGNAME, Buf, 30);
//   LokaLingvo := uppercase(trim(buf));
   LingvoListo := TStringList.Create;
   LingvoListo.Clear;
   For i := 0 to Kurso.FileListBox1.Items.Count-1 do begin
       Prov := TIniFile.Create(Vojo + 'tradukoj/' + Kurso.FileListBox1.Items[i]);
       LingvoListo.Add(uppercase(Prov.ReadString('Traduko', 'LingvoID', 'EN')));
       Tradukoj.Items.Add(SpecLit(Prov.ReadString('Traduko', 'Lingvo', '.....')));
       Prov.Free;
       end;
   LingvoListo.Add('PTB');
   Tradukoj.Items.Add('Portugues (Portugala)');
   Itemo := LingvoListo.IndexOf(LokaLingvo);
   if Itemo >= 0 then
      Tradukoj.ItemIndex := Itemo
   else begin
      for i := 0 to LingvoListo.Count-1 do
          if copy(LokaLingvo,1,2) = copy(LingvoListo[i],1,2) then begin
             Itemo := i;
             Tradukoj.ItemIndex := Itemo;
             break;
             end;
      if itemo < 0 then
         Tradukoj.ItemIndex := LingvoListo.IndexOf('EN');
      end;
   LingvoListo.Free;
end;


procedure TForm17.Button1Click(Sender: TObject);
begin
   Close;
end;

procedure TForm17.FormClose(Sender: TObject; var Action: TCloseAction);
Var Itemo : Integer;
    Prov : TIniFile;
begin
   Itemo := Tradukoj.ItemIndex;
   if (Itemo >= 0) and (Itemo <> Tradukoj.Items.Count-1) then begin
      Prov := TIniFile.Create(Vojo + 'tradukoj/' + Kurso.FileListBox1.Items[Itemo]);
      Konfiguro.WriteString('Gxenerala', 'Dosiero', Kurso.FileListBox1.Items[Itemo]);
      Konfiguro.WriteString('Gxenerala', 'Lingvo', Prov.ReadString('Traduko', 'Lingvo', 'Portugues'));
      Konfiguro.WriteString('Gxenerala', 'Tiparo', Prov.ReadString('Traduko', 'Tiparo', 'Arial'));
      Prov.Free;
      end
   else begin
      Konfiguro.WriteString('Gxenerala', 'Dosiero', '');
      Konfiguro.WriteString('Gxenerala', 'Lingvo', 'Portugues');
      Konfiguro.WriteString('Gxenerala', 'Tiparo', 'Arial');
      end;
end;

end.
