unit Unit19;

interface

uses
  {$IFDEF LINUX} Libc, {$ENDIF} QT {$IFDEF MSWINDOWS} , Windows {$ENDIF}, SysUtils, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, inifiles, QComCtrls, QStaticText, KursoEsp;

type
  TForm19 = class(TForm)
    Tajpu: TMemo;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Legu: TMemo;
    procedure FormShow(Sender: TObject);
    procedure TajpuChange(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TajpuKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form19: TForm19;
  sAntauaTeksto : WideString;
  Nomo: String;
  titolo : String;
  Fonto: TRKSIniFile; { havas la e-an version de la kurso }
  sDosiero: String;

implementation

uses lec01, funkcioj;

{$R *.xfm}

procedure TForm19.FormShow(Sender: TObject);
Var AntauaProgramo : TNotifyEvent;
    Teksto : WideString;
begin
   Nomo := (Kurso.TRadukota as TLabel).Name ;
   if (Kurso.Tradukota as TLabel).Parent is TFrame then begin
      if nomo = 'Label7' then
         nomo := 'TFrame1.'+nomo
      else if nomo = 'PP_Label41' then
         nomo := 'TFrame2.'+nomo
      else if nomo = 'PP_Label1' then
         nomo := 'TFrame2.'+nomo
      else if nomo = 'Label68' then
         nomo := 'TFrame3.'+nomo
      else if nomo = 'Label59' then
         nomo := 'TFrame3.'+nomo
      else if nomo = 'Label6' then
         nomo := 'TFrame5.'+nomo
      else if nomo = 'Label1' then
         nomo := 'TFrame5.'+nomo
      else if nomo = 'Label83' then
         nomo := 'TFrame4.'+nomo
      else if nomo = 'Label84' then
         if (Kurso.Tradukota as TLabel).Parent.Name = 'TFrame41' then
            nomo := 'TFrame41.'+nomo
         else
            nomo := 'Frame42.' + nomo;
      end;
   if (Kurso.Tradukota as TLabel).parent is TFrame then
      if ( ( Nomo = 'Frame42.Label84') or
           ( Nomo = 'TFrame41.Label84') ) then begin
         sEnhavujo := (Kurso.Tradukota as TLabel).Parent.Parent.Parent.Parent.Name;
         Titolo := RedonasLecionon(sEnhavujo);
         end
      else begin
         sEnhavujo := (Kurso.Tradukota as TLabel).parent.Name;
         Titolo := 'gheneralaj';
         end
   else
      Titolo := RedonasLecionon(sEnhavujo);


   Label2.Caption := Titolo;
   Label4.Caption := Nomo;

   sDosiero := vojo + 'tradukoj/' + titolo + '.tdf';
   Fonto := TRKSIniFile.Create(sDosiero);

   AntauaProgramo := Tajpu.OnChange;
   Tajpu.OnChange := nil;
   Teksto := SpecLit(Fonto.ReadString( Nomo , 'Caption', 'ne trovita'));
   if Teksto = 'ne trovita' then
      Teksto := SpecLit(Fonto.ReadString( Nomo , 'caption', 'ne trovita'));

   SetMemoText (Legu, Teksto);

   if (Kurso.Tradukota is TMemo) then
      SAntauaTeksto := (Kurso.Tradukota as TMemo).Text
   else
      SAntauaTeksto := (Kurso.Tradukota as TLabel).Caption;
   if (Kurso.Tradukota as TLabel).AutoSize then
      Tajpu.Width := 620
   else begin
      Tajpu.Width := (Kurso.Tradukota as TLabel).Width;
      if not (Kurso.Tradukota is TMemo) then
         Tajpu.Width := Tajpu.Width + 12;
      end;
   Height := Height + ((Kurso.Tradukota as TControl).Height - Tajpu.Height ) + 12;
   Tajpu.Height := (Kurso.Tradukota as TControl).Height + 12;
   Tajpu.Font := (Kurso.Tradukota as TLabel).Font;
   Tajpu.Font.Color := clBlack;
   SetMemoText( Tajpu, (Kurso.Tradukota as TLabel).Caption);
   Tajpu.OnChange := AntauaProgramo;
   Tajpu.SetFocus;
   Tajpu.SelStart := Length(Tajpu.Text);
end;

procedure TForm19.TajpuChange(Sender: TObject);
Var Provizora : WideSTring;
begin
   If Kurso.Tradukota is TMemo then
      SetMemoText((Kurso.Tradukota as TMemo), GetMemoText(Tajpu))
   else begin
      Provizora := GetMemoText(Tajpu);
      (Kurso.Tradukota as TLabel).Caption := Provizora;
      end;
end;

procedure TForm19.Button2Click(Sender: TObject);
begin
   If Kurso.Tradukota is TMemo then
      SetMemoText((Kurso.Tradukota as TMemo), sAntauaTeksto)
   else
      (Kurso.Tradukota as TLabel).Caption := sAntauaTeksto;
   Close;
end;

procedure TForm19.Button1Click(Sender: TObject);
Var Provizora: WideString;
begin
   Provizora := GetMemoText(Tajpu);
   Provizora := SpecLitSav(Provizora);   
   Tradukado.WriteString( Titolo, nomo, Provizora);
   Tradukado.UpdateFile;
   Close;
end;

procedure TForm19.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Fonto.Free;
end;

procedure TForm19.TajpuKeyPress(Sender: TObject; var Key: Char);
begin
  Cxapelo(Key, Sender);
end;

end.
