unit konfig;

interface

uses
  {$IFDEF LINUX} Libc, {$ENDIF} QT {$IFDEF MSWINDOWS} , Windows {$ENDIF}, SysUtils, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QExtCtrls, {FileCtrl,} QButtons, Kursoesp, inifiles,
  QMask, Funkcioj, QFontComboBox, QStaticText, QComCtrls;

type
  TForm13 = class(TForm)
    Savu: TSpeedButton;
    Eliri: TSpeedButton;
    Konfigurado: TPageControl;
    tiparoj: TTabSheet;
    korektado: TTabSheet;
    Supersigno: TTabSheet;
    Sono_Interreto: TTabSheet;
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Lingvo: TComboBox;
    Label3: TLabel;
    Label10: TLabel;
    Edit3: TEdit;
    Bevel2: TBevel;
    Edit2: TEdit;
    Label7: TLabel;
    Edit1: TEdit;
    Label6: TLabel;
    Label11: TLabel;
    Korektanto: TCheckBox;
    StaticText2: TStaticText;
    Label8: TLabel;
    Label5: TLabel;
    Label4: TLabel;
    Sistemo: TGroupBox;
    SistemoB_2: TCheckBox;
    SistemoB_1: TCheckBox;
    SistemoB_0: TCheckBox;
    Sistemo_2: TLabel;
    Sistemo_1: TLabel;
    Sistemo_0: TLabel;
    Bevel3: TBevel;
    Label9: TLabel;
    Label12: TLabel;
    Cxapeligo: TCheckBox;
    Image1: TImage;
    GroupBox1: TGroupBox;
    Label14: TLabel;
    Label13: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Edit4: TEdit;
    StaticText1: TStaticText;
    Bevel4: TBevel;
    Edit5: TEdit;
    Label17: TLabel;
    Edit6: TEdit;
    Label18: TLabel;
    Edit7: TEdit;
    Label19: TLabel;
    Edit8: TEdit;
    Label20: TLabel;
    Edit9: TEdit;
    Tiparo: TComboBox;
    Esperanta_Tiparo: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure KorektantoClick(Sender: TObject);
    procedure EliriClick(Sender: TObject);
    procedure SavuClick(Sender: TObject);
    procedure LingvoChange(Sender: TObject);
    procedure Tiparo_1Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure SistemoClick(Sender: TObject);
    procedure CxapeligoClick(Sender: TObject);
    procedure TradukuCxion(Modulo: String);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Button1Click(Sender: TObject);
    procedure SuperSigno1Change(Sender: TObject);
    procedure Tradukilo(Sender: TObject);
    procedure KonfiguradoChange(Sender: TObject);
    procedure Esperanta_Tiparo_1Change(Sender: TObject);
    procedure Edit5Change(Sender: TObject);
    procedure Edit6Change(Sender: TObject);
    procedure Edit7Change(Sender: TObject);
    procedure Edit8Change(Sender: TObject);
    procedure Edit9Change(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form13: TForm13;
  LingvoListo, TiparListo, DosierListo, Traduko: TStrings;
  lRekomencu: boolean;
  sLingvo1, sTiparo1, sEsperanta_Tiparo1, sTradukoDosiero1: sTring;
  lKorektantoProv, lCxapeligoProv: boolean;
  iSistemoProv: integer;
  sMP31, sWavPlay1, sWavRec1, sNavigilo1, sMesaghilo1 : string;

implementation

uses Unit19, Figurejo_d;

{$R *.xfm}

procedure TForm13.FormCreate(Sender: TObject);
begin
LingvoListo := TStringList.Create;
TiparListo := TStringList.Create;
Traduko := TStringList.Create;
DosierListo := TStringList.Create;
Eliri.Glyph := Kurso.eliri.Glyph;
Tiparo.Items := Screen.Fonts;
Esperanta_Tiparo.Items := Screen.Fonts;
TradukuCxion('Konfig');
end;

procedure TForm13.KorektantoClick(Sender: TObject);
begin
   Savu.Enabled := true;
   lKorektantoProv := Korektanto.Checked;
   If Konfigurado.ActivePage.Name = 'korektado' then begin
      Edit1.Enabled := lKorektantoProv;
      Edit2.Enabled := lKorektantoProv;
      if lKorektantoProv then
         Edit1.SetFocus;
      end;
//   Sistemo.Enabled := lKorektantoProv;
end;

procedure TForm13.EliriClick(Sender: TObject);
Var Respondo: Word;
begin
   Respondo := mrYes;
   if Savu.Enabled then begin
      Respondo := MessageDlg(smModifis, mtConfirmation, [mbYes, mbNo, mbCancel], 0);
      if Respondo = mrYes then
         Savu.Click;
      end;

   if Respondo <> mrCancel then
      Close;
end;

procedure TForm13.SavuClick(Sender: TObject);
begin
   Konfiguro.WriteString('Gxenerala', 'Tiparo', sTiparo1);
   Konfiguro.WriteString('Gxenerala', 'Lingvo', sLingvo1);
   Konfiguro.WriteString('Gxenerala', 'Dosiero', sTradukoDosiero1);
   Konfiguro.WriteBool('Gxenerala', 'Korektanto', lKorektantoProv);
   Konfiguro.WriteString('Gxenerala', 'Nomo', Edit1.Text);
   Konfiguro.WriteString('Gxenerala', 'Adreso', Edit2.Text);
   Konfiguro.WriteBool('Gxenerala', 'Cxapeligo', lCxapeligoProv);
   Konfiguro.WriteInteger('Gxenerala', 'Sistemo', iSistemoProv);
   Konfiguro.WriteString('Gxenerala', 'MP3', Edit5.Text);
   Konfiguro.WriteString('Gxenerala', 'WavPlay', Edit6.Text);
   Konfiguro.WriteString('Gxenerala', 'WavRec', Edit7.Text);
   Konfiguro.WriteString('Gxenerala', 'Navigilo', Edit8.Text);
   Konfiguro.WriteString('Gxenerala', 'Mesaghilo', Edit9.Text);
   Konfiguro.WriteString('Gxenerala', 'Esperanta_Tiparo', sEsperanta_Tiparo1);
   Savu.Enabled := false;
   Konfiguro.UpdateFile;
   sKorAdreso := Edit2.Text;
   iSistemo := iSistemoProv;
   lCxapeligo := lCxapeligoProv;
   lKorektanto := lKorektantoProv;
   sKorNomo := Edit1.Text;
   sMP3 := sMP31;
   sWavPlay := sWavPlay1;
   sWavRec := sWavRec1;
   sNavigilo := sNavigilo1;
   sMesaghilo := sMesaghilo1;
   Kurso.MP3.Komando := sMP3;
if ( (sLingvo <> sLingvo1) or (sTiparo <> sTiparo1) or
     (sEsperanta_Tiparo <> sEsperanta_Tiparo1) ) then begin
   sEsperanta_Tiparo := sEsperanta_Tiparo1;
   sTiparo := sTiparo1;
   if ((sLingvo1 = 'Portugues') and (sLingvo <> 'Portugues')) then
      MessageDlg('A traduo para o portugus se efetivar quando retornar ao Menu Principal', mtInformation, [mbOK], 0);
   Traduku;
   Tradukucxion('Konfig');
   Edit3.Text := Label1.Caption + ' ' + Label2.Caption;
   Application.ProcessMessages;
   Form13.Caption := Kurso.Konfigurado.Caption;
   end;
end;

procedure TForm13.LingvoChange(Sender: TObject);
Var i: integer;
begin
  Savu.enabled := true;
  i := LingvoListo.IndexOf(Lingvo.Items[Lingvo.ItemIndex]);
  sLingvo1 := Lingvo.Items[Lingvo.ItemIndex];
  if i > -1 then begin
     sTiparo1 := TiparListo.Strings[i];
     Tiparo.ItemIndex := Tiparo.Items.IndexOf(sTiparo1);
     if Tiparo.ItemIndex < 0 then begin
        sTiparo1 := Screen.HintFont.Name;
        Tiparo.ItemIndex := Tiparo.Items.IndexOf(sTiparo1);
        end;
     sTradukoDosiero1 := DosierListo.Strings[i];
     end
  else begin
     sTiparo1 := Screen.HintFont.Name;
     Tiparo.ItemIndex := Tiparo.Items.IndexOf(sTiparo1);
     end;
  Edit3.Font.Name := sTiparo1;
end;

procedure TForm13.Tiparo_1Change(Sender: TObject);
begin
   Savu.Enabled := true;
   if Tiparo.ItemIndex < 0 then
      Tiparo.ItemIndex := 0;
   sTiparo1 := Tiparo.Items[Tiparo.ItemIndex];
   Edit3.Font.Name := sTiparo1;
end;

procedure TForm13.FormShow(Sender: TObject);
Var i: integer;
    Prov: TIniFile;
    SistemoProv: TNotifyEvent;
    OnChangeProv, OnChangeProv1, OnChangeProv2 : TNotifyEvent;
begin
// Form13.Top := ((Kurso.Height - Form13.Height) div 2) + Kurso.Top;
// Form13.Left := ((Kurso.Width - Form13.Width) div 2) + Kurso.Left;
Form13.Caption := Kurso.Konfigurado.Caption;
LingvoListo.Clear;
TiparListo.Clear;
Traduko.Clear;
DosierListo.Clear;
Konfiguro.ReadSection('Tradukoj', Traduko);
For i := 0 to Kurso.FileListBox1.Items.Count-1 do begin
    Prov := TIniFile.Create(Vojo + 'tradukoj/' + Kurso.FileListBox1.Items[i]);
    LingvoListo.Add(SpecLit(Prov.ReadString('Traduko', 'Lingvo', '......')));
    TiparListo.Add(SpecLit(Prov.ReadString('Traduko',  'Tiparo', 'Lucidux Sans')));
    DosierListo.Add(Kurso.FileListBox1.Items[i]);
    Lingvo.Items.Add(LingvoListo.Strings[i]);
    Prov.Free;
    end;
OnChangeProv := Lingvo.Onchange;
OnChangeProv1 := Tiparo.Onchange;
OnChangeProv2 := Esperanta_Tiparo.Onchange;
Lingvo.OnChange := Lingvo.OnCloseUp;
Tiparo.OnChange := Lingvo.OnCloseUp;
Esperanta_Tiparo.OnChange := Lingvo.OnCloseUp;
Lingvo.ItemIndex := Lingvo.Items.IndexOf(sLingvo);
Tiparo.ItemIndex := Tiparo.Items.IndexOf(sTiparo);
Esperanta_Tiparo.ItemIndex := Esperanta_Tiparo.Items.IndexOf(sEsperanta_Tiparo);
Lingvo.OnChange := OnChangeProv;
Tiparo.OnChange := OnChangeProv1;
Esperanta_Tiparo.OnChange := OnChangeProv2;
Edit3.Font.Name := sTiparo;
Edit4.Font.Name := sEsperanta_Tiparo;
Korektanto.Checked := lKorektanto;
Edit1.Text := sKorNomo;
Edit2.Text := sKorAdreso;
iSistemoProv := iSistemo;
lKorektantoProv := lKorektanto;
lCxapeligoProv := lCxapeligo;
sMP31 := sMP3;
sWavPlay1 := sWavPlay;
sWavRec1 := sWavRec;
sNavigilo1 := sNavigilo;
sMesaghilo1 := sMesaghilo;
sEsperanta_Tiparo1 := sEsperanta_Tiparo;
Edit5.Text := sMP3;
Edit6.Text := sWavPlay;
Edit7.Text := sWavRec;
Edit8.Text := sNavigilo;
Edit9.Text := sMesaghilo;
SistemoProv := SistemoB_0.OnClick;
SistemoB_0.OnClick := nil;
SistemoB_1.OnClick := nil;
SistemoB_2.OnClick := nil;
SistemoB_0.Checked := (SistemoB_0.Tag = iSistemoProv);
SistemoB_1.Checked := (SistemoB_1.Tag = iSistemoProv);
SistemoB_2.Checked := (SistemoB_2.Tag = iSistemoProv);
SistemoB_0.OnClick := SistemoProv;
SistemoB_1.OnClick := SistemoProv;
SistemoB_2.OnClick := SistemoProv;
sLingvo1 := sLingvo;
sTiparo1 := sTiparo;
sTradukoDosiero1 := sTradukoDosiero;
Cxapeligo.Checked := lCxapeligo;
Edit3.Text := Label1.Caption + ' ' + Label2.Caption;
Savu.Enabled := false;
Konfigurado.ActivePageIndex := 0;
end;

procedure TForm13.FormDestroy(Sender: TObject);
begin
LingvoListo.Free;
TiparListo.Free;
Traduko.Free;
DosierListo.Free;
end;

procedure TForm13.Edit1Change(Sender: TObject);
begin
   Savu.Enabled := true;
end;

procedure TForm13.SistemoClick(Sender: TObject);
Var Kliko : TNotifyEvent;
begin
With (Sender as TCheckBox) do begin
   Savu.Enabled := true;
   Kliko := SistemoB_0.OnClick;

   SistemoB_0.OnClick := nil;
   SistemoB_1.OnClick := nil;
   SistemoB_2.OnClick := nil;

   SistemoB_0.Checked := ((Tag = SistemoB_0.Tag));
   SistemoB_1.Checked := ((Tag = SistemoB_1.Tag));
   SistemoB_2.Checked := ((Tag = SistemoB_2.Tag));
   if Checked then
      iSistemoProv := Tag;
   end;
   Application.ProcessMessages;
   SistemoB_0.OnClick := Kliko;
   SistemoB_1.OnClick := Kliko;
   SistemoB_2.OnClick := Kliko;

end;

procedure TForm13.CxapeligoClick(Sender: TObject);
begin
  lCxapeligoProv := Cxapeligo.Checked;
  Savu.Enabled := true;
end;

procedure TForm13.TradukuCxion(Modulo: String);
Var i: integer;
begin
   Lingvo.Font.Name := sTiparo;
   if sLingvo = 'Portugues' then begin
       For i := 0 to ComponentCount -1 do begin
           if ( ( Components[i] is TButton ) or (Components[i] is TStaticText) or
                 (( Components[i] is TEdit ) and ( TEdit(Components[i]).Tag in [128..255] )) or
                 (( Components[i] is TMemo ) and not( TMemo(Components[i]).Tag in [128..255] )) ) then begin
                    TLabel(Components[i]).Font.Name := sEsperanta_Tiparo;
                 end
           else begin
           if ((Components[i] is  TLabel) and not(Components[i] is TStaticText))
               or (Components[i] is TEdit) or (Components[i] is TGroupBox or (Components[i] is TPageControl))  then begin
                TLabel(Components[i]).Font.Name := sTiparo;
                end;
           end;
           end;
      end
   else
           For i := 0 to ComponentCount -1 do begin

              if ( ( Components[i] is TButton ) or (Components[i] is TStaticText) or
                 (( Components[i] is TEdit ) and ( TEdit(Components[i]).Tag in [128..255] )) or
                 (( Components[i] is TMemo ) and not( TMemo(Components[i]).Tag in [128..255] )) ) then begin
                    TLabel(Components[i]).Font.Name := sEsperanta_Tiparo;
                 end;

               if ((Components[i] is TLabel) and not(Components[i] is TStaticText) or (Components[i] is TTabSheet)) then begin
                  TLabel(Components[i]).Caption := SpecLit(Tradukado.ReadString(Modulo, TLabel(Components[i]).Name, 'Ne Tradukita'));
                  TLabel(Components[i]).Font.Name := sTiparo;
                  end;
               if (Components[i] is TTabSheet) then begin
                  TTabSheet(Components[i]).Caption := SpecLit(Tradukado.ReadString(Modulo, TTabSheet(Components[i]).Name, 'Ne Tradukita'));
                  TTabSheet(Components[i]).Font.Name := sTiparo;
                  end;
               if (( Components[i] is TEdit ) and not( TEdit(Components[i]).Tag in [128..255] )) then begin
                  TEdit(Components[i]).Font.Name := sTiparo;
                  end;
               if (Components[i] is TGroupBox) then begin
                  TGroupBox(Components[i]).Font.Name := sTiparo;
                  end;
               end;

end;

procedure TForm13.FormKeyPress(Sender: TObject; var Key: Char);
begin
  Cxapelo(Key, TObject(ActiveControl));
end;

procedure TForm13.Button1Click(Sender: TObject);
Var x: String;
begin
   x := (Sender as TStaticText).Caption;
   VokasEksteran(x, 1);
end;

procedure TForm13.SuperSigno1Change(Sender: TObject);
begin
  Savu.Enabled := true;
end;

procedure TForm13.Tradukilo(Sender: TObject);
begin
Tradukas(Sender, Name);
end;

procedure TForm13.KonfiguradoChange(Sender: TObject);
begin
   If Konfigurado.ActivePage.Name = 'Korektado' then begin
      Edit1.Enabled := Korektanto.Checked;
      Edit2.Enabled := Korektanto.Checked;
      end;
   If Konfigurado.ActivePage.Name = 'Supersigno' then
      Sistemo.Enabled := Korektanto.Checked;
end;

procedure TForm13.Esperanta_Tiparo_1Change(Sender: TObject);
begin
   Savu.Enabled := true;
   sEsperanta_Tiparo1 := Esperanta_Tiparo.Items[Esperanta_Tiparo.ItemIndex];
   Edit4.Font.Name := sEsperanta_Tiparo1;
end;

procedure TForm13.Edit5Change(Sender: TObject);
begin
   sMP31 := Edit5.Text;
   Savu.Enabled := true;
end;

procedure TForm13.Edit6Change(Sender: TObject);
begin
  sWavPlay1 := Edit6.Text;
   Savu.Enabled := true;
end;

procedure TForm13.Edit7Change(Sender: TObject);
begin
  sWavRec1 := Edit7.Text;
  Savu.Enabled := true;
end;

procedure TForm13.Edit8Change(Sender: TObject);
begin
  sNavigilo1 := Edit8.Text;
  Savu.Enabled := true;
end;

procedure TForm13.Edit9Change(Sender: TObject);
begin
  sMesaghilo1 := Edit9.Text;
   Savu.Enabled := true;
end;

end.
